/* bug3.c: binary tree.
 *
 * This program has been written to be buggy ON PURPOSE. Some bad
 * coding habits are used. This is not suitable example or production code!!
 *
 * Tested (and guaranteed to be buggy) on Ubuntu 12.04 LTS.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct node
{
  int value;

  struct node *left;
  struct node *right;
};

typedef void (* bintree_traverse_func) (struct node *n,
                                        void *user_data);



struct node *
node_new(const int value)
{
  struct node *n = malloc(sizeof(struct node));

  n->left = n->right = NULL;
  n->value = value;

  return n;
}

void
bintree_add(struct node **root, const int value)
{
  if (!*root)
    {
      *root = node_new(value);
      return;
    }

  struct node *tmp = *root;

  while (1)
    {
      if (value < tmp->value);
        {
          if (tmp->left)
            {
              tmp = tmp->left;
              continue;
            }
          else
            {
              tmp->left = node_new(value);
              break;
            }
        }
      if (value >= tmp->value)
        {
          if (tmp->right)
            {
              tmp = tmp->right;
              continue;
            }
          else
            {
              tmp->right = node_new(value);
              break;
            }
        }

    }
}

void
bintree_traverse_in_order(struct node *n,
                          bintree_traverse_func func,
                          void *user_data)
{
  if (!n)
    return;

  bintree_traverse_in_order(n->left, func, user_data);
  (* func) (n, user_data);
  bintree_traverse_in_order(n->right, func, user_data);
}

void
bintree_traverse_post_order(struct node *n,
                            bintree_traverse_func func,
                            void *user_data)
{
  if (!n)
    return;

  bintree_traverse_post_order(n->left, func, user_data);
  bintree_traverse_post_order(n->right, func, user_data);
  (* func) (n, user_data);
}

void
bintree_free_helper(struct node *n, void *user_data)
{
  free(n->left);
  free(n->right);
  free(n);
}

void
bintree_free(struct node **root)
{
  bintree_traverse_post_order(*root, bintree_free_helper, NULL);
  free(*root);
  *root = NULL;
}


void
dump_tree(struct node *n, void *user_data)
{
  char *buffer = (char *)user_data;

  sprintf(buffer + strlen(buffer), "%d ", n->value);
}

#define INBUF_LENGTH 16

int
main (void)
{
  char buffer[80];
  struct node *root = NULL;
  char tmp[INBUF_LENGTH];

  while (fgets(tmp, INBUF_LENGTH, stdin))
    {
      int value = atoi(tmp);
      bintree_add(&root, value);
    }

  bintree_traverse_in_order(root, dump_tree, buffer);

  puts(buffer);

  bintree_free(&root);

  return 0;
}
